#include <stdio.h>
#include <stdlib.h>

#include <X11/Xlib.h>

#include "kconfig.h"
#include "dwmstatus.h"

static Display *dpy;


int
stradd( bbuf *a, bbuf *b )
{
	int i=0,j=0;
	for ( i=0; 
	  i<a->size-1, a->str[i]!='\0'; 
	  i++){}
	
	for (j=0;
	  (i+j)<a->size-1, j<b->size-1;
	  j++)
	{
		a->str[i+j] = b->str[j];
	}
	return 0;
}

void
setstatus(char *str)
{
	XStoreName(dpy, DefaultRootWindow(dpy), str);
	XSync(dpy, False);
}

int main( int argc, char **argv )
{
	//char *status=NULL;
	bbuf status; memset( &status, 0, sizeof(status) );
	bbuf time; memset( &time, 0, sizeof(time) );
	bbuf date; memset( &date, 0, sizeof(date) );


	if (status.size == 0)
	{
		status.size = 1024;
		status.str = malloc( status.size );
		memset( status.str, 0, status.size );
	}

	
	if (!(dpy = XOpenDisplay(NULL)))
	{
		printf("cannot open display.\n");
		return -11;
	}

	for (;;sleep(1))
	{
		status.str[0]=0;
	
	#ifdef CONFIG_STATUS_TIME
		print_time( &time );
		stradd( &status, &time );
	#endif

	#ifdef CONFIG_STATUS_DATE
		print_date( &date );
		stradd( &status, &date );
	#endif

		//printf("%s\n", time.str);
		setstatus(status.str);
	}

	XCloseDisplay(dpy);

	return 0;
}
